Siddhi Core Libraries
=====================

  [![Jenkins Build Status](https://wso2.org/jenkins/view/wso2-dependencies/job/siddhi/job/siddhi/badge/icon)](https://wso2.org/jenkins/view/wso2-dependencies/job/siddhi/job/siddhi)
  [![GitHub Release](https://img.shields.io/github/release/siddhi-io/siddhi.svg)](https://github.com/siddhi-io/siddhi/releases)
  [![GitHub Release Date](https://img.shields.io/github/release-date/siddhi-io/siddhi.svg)](https://github.com/siddhi-io/siddhi/releases)
  [![GitHub Open Issues](https://img.shields.io/github/issues-raw/siddhi-io/siddhi.svg)](https://github.com/siddhi-io/siddhi/commits/master)
  [![GitHub Last Commit](https://img.shields.io/github/last-commit/siddhi-io/siddhi.svg)](https://github.com/siddhi-io/siddhi/commits/master)
  [![Codecov](https://codecov.io/gh/siddhi-io/siddhi/branch/master/graph/badge.svg)](https://codecov.io/gh/siddhi-io/siddhi)
  [![CII Best Practices](https://bestpractices.coreinfrastructure.org/projects/2974/badge)](https://bestpractices.coreinfrastructure.org/projects/2974)
  [![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)

<a target="_blank" href="https://siddhi.io/">Siddhi</a> is a cloud native **_Streaming_** and **_Complex Event Processing_** engine that understands **Streaming SQL queries** in order to capture events from diverse data sources, process them, detect complex conditions, and publish output to various endpoints in real time.

**Siddhi Core Libraries** contains the essential core libraries need for Siddhi execution such as [`siddhi-core`](https://github.com/siddhi-io/siddhi/tree/master/modules/siddhi-core), [`siddhi-query-api`](https://github.com/siddhi-io/siddhi/tree/master/modules/siddhi-query-api), [`siddhi-query-compiler`](https://github.com/siddhi-io/siddhi/tree/master/modules/siddhi-query-compiler), and [`siddhi-annotations`](https://github.com/siddhi-io/siddhi/tree/master/modules/siddhi-annotations).

## Overview 

![](https://raw.githubusercontent.com/siddhi-io/siddhi/master/docs/images/siddhi-overview.png?raw=true "Overview")

Siddhi can run as an embedded Java and Python library, as a micro service on bare metal, VM, and Docker and natively in Kubernetes. 

Siddhi provides web-based graphical and textual tooling for development.

For information on <a target="_blank" href="https://siddhi.io/">Siddhi</a> and it's features refer <a target="_blank" href="https://siddhi.io/redirect/docs.html">Siddhi Documentation</a>. 

## Download 

Download Siddhi Core Libraries;

* Versions 5.x and above with group id `io.siddhi.*` from <a target="_blank" href="https://mvnrepository.com/artifact/io.siddhi/">here</a>.
* Versions 4.x and lower with group id `org.wso2.siddhi.*` from <a target="_blank" href="https://mvnrepository.com/artifact/org.wso2.siddhi/">here</a>.

Download Siddhi tooling and runtime distributions <a target="_blank" href="https://siddhi.io/redirect/download.html">here</a>.

## Get Started!

Get started with Siddhi in a few minutes by following the <a target="_blank" href="https://siddhi.io/redirect/quick-start.html">Siddhi Quick Start Guide</a>. 

For more information on using Siddhi refer <a target="_blank" href="https://siddhi.io/redirect/docs.html">Siddhi Documentation</a>. 

## Latest API Docs 

Latest API Docs is <a target="_blank" href="https://siddhi-io.github.io/siddhi/api/5.1.13">5.1.13</a>.

## Support and Contribution

You can reachout through Slack channel, Google mail group and etc. Please refer the community contribution [site](https://siddhi.io/community/) for more information.

